routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\TagsController;
use App\Http\Controllers\CategoriesController;
use App\Http\Controllers\CommentsController;
use App\Http\Controllers\FrontendController;
use App\Http\Controllers\PostsController;
use App\Http\Controllers\UsersController;




Route::prefix('admin')->middleware(['auth'])->group(function () {
    Route::get('/dashboard', function () {
        return view('admin-panel.dashboard');
    })->name('dashboard');
    Route::put('/users/{user}/make-admin',[UsersController::class,'makeAdmin'])->name('users.makeAdmin');
    Route::put('/users/{user}/revoke-admin',[UsersController::class,'revokeAdmin'])->name('users.revokeAdmin');
    Route::resource('users', UsersController::class);
    Route::resource('tags', TagsController::class)->except(['show']);
    Route::resource('categories', CategoriesController::class)->except(['show']);

    Route::get('/posts/trashed',[PostsController::class,'trashed'])->name('posts.trashed');




    Route::resource('posts', PostsController::class);
    Route::put('posts/{post}/publish-now',[PostsController::class,'publish'])->name('posts.publish');

    Route::put('posts/trashed/{post}/restore',[PostsController::class,'restore'])->name('posts.restore');
    Route::delete('posts/trashed/{post}/destroy',[PostsController::class,'forceDelete'])->name('posts.forceDelete');

});
Route::get('/',[FrontendController::class,'index']);
Route::resource('comments', CommentsController::class);

Route::get('/categories/{category}',[FrontendController::class,'category'])->name('blogs.category');
Route::get('/tags/{tag}',[FrontendController::class,'tag'])->name('blogs.tag');
Route::get('/blogs/{post}',[FrontendController::class,'show'])->name('blogs.show');





// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('/dashboard', function () {
    return view('admin-panel.dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__.'/auth.php';

app/Models/Tag.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tag extends Model
{
    use HasFactory;
    protected $guarded = [];

    public function posts() {
        return $this->belongsToMany(Post::class);
    }
}

app/Http/Controllers/TagsController.php
<?php

namespace App\Http\Controllers;

use App\Models\Tag;
use Illuminate\Http\Request;
use App\Http\Requests\CreateTagRequest;
use App\Http\Requests\UpdateTagRequest;


class TagsController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {   $tags = Tag::latest()->paginate(5);
        // dd($tags);
        return view('admin-panel.tags.index',compact('tags'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('admin-panel.tags.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CreateTagRequest $request)
    {
        // dd($request->all);
        Tag::create($request->all());
        return redirect(route('tags.index'))->with('success','Tag Created Successfully');

    }

    /**
     * Display the specified resource.
     */
    public function show(Tag $tag)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Tag $tag)
    {
        return view('admin-panel.tags.edit',compact('tag'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateTagRequest $request, Tag $tag)
    {   $tag->name = $request->name;

        if($tag->isClean()){
             return redirect(route('tags.index'))->with('error','No changes made');
        }
        $tag->save();
        // Tag::update($request->except(['id']));
        return redirect(route('tags.index'))->with('success','Tag Updated Successfully');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Tag $tag)
    {
        if($tag->posts()->limit(1)->first()) {
            return redirect(route('tags.index'))
            ->with('error','Tag cannot be Deleted , as there exists post on this tag!');
        }
        $tag->delete();
        return redirect(route('tags.index'))->with('success','Tag Deleted Successfully');
    }
}

resources/views/admin-panel/tags/create.blade.php
{{-- {{ dd($tags) }} --}}
@extends('admin-panel.layouts.admin')

@section('admin-content')
<div class="container-fluid my-3 px-3" >
    <form action="{{route('tags.store')}}" method="POST">
        @csrf
        <div class="form-group">
          <label for="name">Tag Name</label>
          <input name="name" type="text" class="form-control" id="name" aria-describedby="nameHelp" placeholder="Enter tag name" value="{{old('name')}}">
          <small id="nameHelp" class="form-text text-danger"> @error('name') {{ $message }} @enderror </small>
        </div>
        <button type="submit" class="btn btn-primary my-2">Submit</button>
    </form>
</div>
@endsection

resources/views/admin-panel/tags/edit.blade.php
@extends('admin-panel.layouts.admin')
{{-- {{dd($tag)}}; --}}
@section('admin-content')
<div class="container-fluid my-3 px-3" >
    <form action="{{route('tags.update',$tag->id)}}" method="POST">
        @method('PUT')
        @csrf
        <div class="form-group">
          <label for="name">Tag Name</label>
          <input name="name" type="text" class="form-control" id="name" aria-describedby="nameHelp" placeholder="Enter tag name" value="{{$tag->name}}">
          <small id="nameHelp" class="form-text text-danger"> @error('name') {{ $message }} @enderror </small>
        </div>
        <button type="submit" class="btn btn-primary my-2">Submit</button>
    </form>
</div>
@endsection

resources/views/admin-panel/tags/index.blade.php
{{-- {{ dd($tags) }} --}}
@extends('admin-panel.layouts.admin')

@section('admin-content')

    <div class="container-fluid px-4 mt-4">
        <div class="row">
            <div class="col-md-12">
                <div class="card mb-4">
                    <div class="card-header">
                        <div class="d-flex justify-content-between">
                            <div>
                                <svg class="svg-inline--fa fa-table me-1" aria-hidden="true" focusable="false" data-prefix="fas" data-icon="table" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" data-fa-i2svg=""><path fill="currentColor" d="M64 256V160H224v96H64zm0 64H224v96H64V320zm224 96V320H448v96H288zM448 256H288V160H448v96zM64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H448c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64z"></path></svg>
                                <h1 class="mt-4 d-inline">Tags</h1>
                            </div>
                            <a href="{{route('tags.create')}}" class="btn btn-outline-primary">Add Tag</a>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="datatable-wrapper datatable-loading no-footer sortable searchable fixed-columns">
                            <div class="datatable-container">
                                <table id="datatablesSimple" class="datatable-table">
                                    <thead>
                                        <tr>
                                            <th>#</th>
                                            <th>Name</th>
                                            <th>Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($tags as $tag )
                                        <tr >
                                            <td>{{$tag->id}}</td>
                                            <td>{{$tag->name}}</td>
                                            <td><a href="{{route('tags.edit',$tag->id)}}" class="btn btn-warning"> <i class="fa-solid fa-pen"></i></a>
                                                {{-- <button data-tag-id="{{$tag->id}}" class="delete-tag btn btn-danger"><i class="fa-solid fa-trash"></i></button> --}}
                                                <button data-delete-route="{{route('tags.destroy',$tag->id)}}" class="delete-tag btn btn-danger"><i class="fa-solid fa-trash"></i></button>

                                            </td>
                                        </tr>
                                        @endforeach
                                    </tbody>
                                </table>
                            </div>
                            <div class="datatable-bottom">
                                {{$tags->links()}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{{-- Delete Modal --}}
<div class="modal fade" id="deleteModal" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Delete Tag?</h5>
          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
          </button>
        </div>
        <div class="modal-body">
          Are you sure you want to delete this tag?
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          <form action="" class="d-inline-block" id="deleteForm" method="POST">
            @csrf
            @method('delete')
            <button type="submit" class="btn btn-primary">Delete Tag</button>
          </form>
        </div>
      </div>
    </div>
  </div>
{{-- <script>
    const deleteBtn = document.querySelectorAll('.delete-tag');
    deleteBtn.forEach((btn)=> btn.addEventListener('click', deleteTag));
    function deleteTag() {
        const tagId = this.dataset.tagId;
        const route = `/tags/${tagId}`;
        const deleteForm = document.querySelector('#deleteForm');
        deleteForm.setAttribute('action', route);
        const deleteModal = new bootstrap.Modal('#deleteModal');
        deleteModal.show();
        // console.log("Delete Pressed!!");
    }
</script> --}}
@endsection

@section('page-level-scripts')
    <script src="{{asset('admin/js/page-level/tags/index.js')}}"></script>
@endsection